package net.sf.sido.editor;

import org.apache.commons.lang.StringUtils;
import org.joda.time.DateTime;
import org.joda.time.format.ISODateTimeFormat;

public class DateTimeEditor implements DataEditor<DateTime> {

	@Override
	public String toString(DateTime value) {
		if (value == null) {
			return null;
		} else {
			return ISODateTimeFormat.dateTime().print(value);
		}
	}

	@Override
	public DateTime valueOf(String value) {
		if (StringUtils.isBlank(value)) {
			return null;
		} else {
			return ISODateTimeFormat.dateTime().parseDateTime(value);
		}
	}

}
