package net.sf.sido.editor;

import java.lang.reflect.Method;

import org.apache.commons.lang.StringUtils;

public class SimpleEditor<T> extends AbstractDataEditor<T> {

	public static <T> SimpleEditor<T> get(Class<T> type) {
		return new SimpleEditor<T>(type);
	}

	private final Class<T> type;

	public SimpleEditor(Class<T> type) {
		this.type = type;
	}

	@SuppressWarnings("unchecked")
	@Override
	public T valueOf(String value) {
		if (StringUtils.isBlank(value)) {
			return null;
		} else {
			try {
				Method method = this.type.getMethod("valueOf", String.class);
				return (T) method.invoke(null, value);
			} catch (Exception ex) {
				throw new DOSimpleEditorParsingException(value, this.type.getName());
			}
		}
	}
}
