package net.sf.sido.support;

import net.sf.sido.DOException;
import net.sf.sido.DataObject;
import net.sf.sido.Property;
import net.sf.sido.ValidationResults;
import net.sf.sido.VisitorContext;

public class ValidationDataObjectVisitor extends DataObjectVisitorAdapter {

	// Validation results
	private final DefaultValidationResults results = new DefaultValidationResults();

	public ValidationResults getResults() {
		return this.results;
	}

	@Override
	public <T> void visit(VisitorContext context, DataObject o, Property<T> property) {
		T value = o.getValue(property);
		try {
			property.apply(o, value);
		} catch (DOException ex) {
			String path = new DefaultVisitorContext(context, property.getName()).getVisitPath();
			this.results.addError(path, ex);
		}
	}

}
